package com.biganto.visual.roompark.presentation.screen.photo.util

import android.view.View
import butterknife.BindView
import com.biganto.visual.roompark.R
import com.biganto.visual.roompark.base.RoomParkApplication
import com.biganto.visual.roompark.domain.model.PhotoModel
import com.biganto.visual.roompark.domain.model.PhotoResolutionModel
import com.biganto.visual.roompark.presentation.screen.settings.util.CommonRecyclerAdapter
import com.biganto.visual.roompark.presentation.screen.settings.util.CommonViewHolder
import com.github.chrisbanes.photoview.PhotoView
import timber.log.Timber

/**
 * Created by Vladislav Bogdashkin on 16.10.2019.
 */


class PhotosAdapter : CommonRecyclerAdapter<PhotosViewHolder, PhotoModel>() {

    val photosPreviewList:List<String> get() {
         val ret =  list.map {  it.resolutionList.lowelest()?.url?: error("No res urls!")}.toList()
        Timber.d("$ret")
        return ret

    }


    override val vhKlazz = PhotosViewHolder::class

    override fun getVhLayout(): Int = R.layout.photo_page_viewholder
}

class PhotosViewHolder(itemView: View) : CommonViewHolder<PhotoModel>(itemView) {

    @BindView(R.id.photo_view) lateinit var photoPreview: PhotoView

    private val picassoAsync by lazy {
        return@lazy RoomParkApplication.component.providePicassoAsync()
    }

    override fun onViewBound(model: PhotoModel) {
        model.resolutionList.lowelest()?.let {
            picassoAsync
                .load(it.url)
                .centerCrop()
                .fit()
                .into(photoPreview)
        }}
}

private fun List<PhotoResolutionModel>.lowelest() =
    this.minBy { it.resWidth * it.resHeight }